"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _core = require("@astql/core");

var _defaultParserInterface = _interopRequireDefault(require("@astql/core/utils/defaultParserInterface"));

var _package = _interopRequireDefault(require("htmlparser2/package.json"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ID = 'htmlparser2';

var _default = (0, _extends2["default"])({}, _defaultParserInterface["default"], {
  id: ID,
  displayName: ID,
  version: _package["default"].version,
  homepage: _package["default"].homepage || 'https://github.com/fb55/htmlparser2',
  locationProps: new Set(['startIndex']),
  typeProps: new Set(['type', 'name']),
  loadParser: function loadParser(callback) {
    (0, _core.multipleRequire)(['htmlparser2/lib/Parser', 'domhandler'], function (Parser, _ref) {
      var DomHandler = _ref.DomHandler;

      var Handler = /*#__PURE__*/function (_DomHandler) {
        (0, _inherits2["default"])(Handler, _DomHandler);

        var _super = _createSuper(Handler);

        function Handler() {
          (0, _classCallCheck2["default"])(this, Handler);
          return _super.call(this, {
            withStartIndices: true,
            withEndIndices: true
          });
        } // It appears that htmlparser2 doesn't correctly process
        // ProcessingInstructions. Their "endIndex" isn't set properly.


        (0, _createClass2["default"])(Handler, [{
          key: "onprocessinginstruction",
          value: function onprocessinginstruction(name, data) {
            this.parser.endIndex = this.parser.tokenizer._index;
            (0, _get2["default"])((0, _getPrototypeOf2["default"])(Handler.prototype), "onprocessinginstruction", this).call(this, name, data);
          }
        }]);
        return Handler;
      }(DomHandler);

      callback({
        Parser: Parser,
        Handler: Handler
      });
    });
  },
  parse: function parse(_ref2, code, options) {
    var Parser = _ref2.Parser.Parser,
        Handler = _ref2.Handler;
    var handler = new Handler();
    new Parser(handler, options).end(code);
    return handler.root;
  },
  nodeToRange: function nodeToRange(node) {
    if (node.type) {
      return [node.startIndex, node.endIndex + 1];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return key === 'children';
  },
  getNodeName: function getNodeName(node) {
    var nodeName = node.type;

    if (nodeName && node.name) {
      nodeName += "(".concat(node.name, ")");
    }

    return nodeName;
  },
  getDefaultOptions: function getDefaultOptions() {
    return {
      xmlMode: false,
      lowerCaseAttributeNames: true,
      lowerCaseTags: true
    };
  },
  _ignoredProperties: new Set(['prev', 'next', 'parent', 'parentNode'])
});

exports["default"] = _default;