import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _get from "@babel/runtime/helpers/get";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _extends from "@babel/runtime/helpers/extends";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

import { multipleRequire } from '@astql/core';
import defaultParserInterface from '@astql/core/utils/defaultParserInterface';
import pkg from 'htmlparser2/package.json';
var ID = 'htmlparser2';
export default _extends({}, defaultParserInterface, {
  id: ID,
  displayName: ID,
  version: pkg.version,
  homepage: pkg.homepage || 'https://github.com/fb55/htmlparser2',
  locationProps: new Set(['startIndex']),
  typeProps: new Set(['type', 'name']),
  loadParser: function loadParser(callback) {
    multipleRequire(['htmlparser2/lib/Parser', 'domhandler'], function (Parser, _ref) {
      var DomHandler = _ref.DomHandler;

      var Handler = /*#__PURE__*/function (_DomHandler) {
        _inherits(Handler, _DomHandler);

        var _super = _createSuper(Handler);

        function Handler() {
          _classCallCheck(this, Handler);

          return _super.call(this, {
            withStartIndices: true,
            withEndIndices: true
          });
        } // It appears that htmlparser2 doesn't correctly process
        // ProcessingInstructions. Their "endIndex" isn't set properly.


        _createClass(Handler, [{
          key: "onprocessinginstruction",
          value: function onprocessinginstruction(name, data) {
            this.parser.endIndex = this.parser.tokenizer._index;

            _get(_getPrototypeOf(Handler.prototype), "onprocessinginstruction", this).call(this, name, data);
          }
        }]);

        return Handler;
      }(DomHandler);

      callback({
        Parser: Parser,
        Handler: Handler
      });
    });
  },
  parse: function parse(_ref2, code, options) {
    var Parser = _ref2.Parser.Parser,
        Handler = _ref2.Handler;
    var handler = new Handler();
    new Parser(handler, options).end(code);
    return handler.root;
  },
  nodeToRange: function nodeToRange(node) {
    if (node.type) {
      return [node.startIndex, node.endIndex + 1];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return key === 'children';
  },
  getNodeName: function getNodeName(node) {
    var nodeName = node.type;

    if (nodeName && node.name) {
      nodeName += "(".concat(node.name, ")");
    }

    return nodeName;
  },
  getDefaultOptions: function getDefaultOptions() {
    return {
      xmlMode: false,
      lowerCaseAttributeNames: true,
      lowerCaseTags: true
    };
  },
  _ignoredProperties: new Set(['prev', 'next', 'parent', 'parentNode'])
});